#include <opnet.h>
#include <ema.h>
#include <opnet_emadefs.h>
#include <opnet_constants.h>



/* array for all textlist attributes in model */
VosT_Textlist*		tl_ptr [17];

/* array for all objects in model */
EmaT_Object_Id		obj [54];



main (argc, argv)
	int	argc;
	char	*argv[];
	{
	EmaT_Model_Id			model_id;
	int					i;

	/* initialize EMA package */
	Ema_Init (EMAC_MODE_ERR_PRINT);

	/* create an empty model */
	model_id = Ema_Model_Create (MOD_PROCESS);



	/* create all objects */
	obj [0] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [1] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [2] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [3] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [4] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [5] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [6] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [7] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [8] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [9] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [10] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [11] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [12] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [13] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [14] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [15] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [16] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [17] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [18] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [19] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [20] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [21] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [22] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [23] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [24] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [25] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [26] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [27] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [28] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [29] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [30] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [31] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [32] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [33] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [34] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [35] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [36] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [37] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [38] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [39] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [40] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [41] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [42] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [43] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [44] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [45] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [46] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [47] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [48] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [49] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [50] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [51] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [52] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [53] = Ema_Object_Create (model_id, OBJ_PR_POS);


	/* set the model level attributes */
	/* create and init textlist 'tl_ptr [0]' */
	tl_ptr [0] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [0], 
		"int      				\\server_busy,\\rte_tab[501],\\gwy_type;",
		"int      				\\Indep_Rou,\\mc_join[100][100];",
		"double   				\\service_rate;",
		"Objid    				\\own_id, \\sub_netid;",
		"int						\\net_num0, \\node_num0;",
		"int						\\net_num1, \\node_num1;",
		"int						\\net_num2, \\node_num2;",
		"int						\\net_num3, \\node_num3;",
		"int						\\net_num4, \\node_num4;",
		"Ici*					\\arp_iciptr",
		"ip_dgram_list*			\\dgram_list_ptr;",
		"int					\\def_str,\\default_ttl,\\n_links;",
		"",
		"",
		"mc_id			 		\\mc_table[100];",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [1]' */
	tl_ptr [1] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [1], 
		"Objid		dup_lk_id;",
		"double          pk_svc_time;",
		"int             insert_ok;",
		"int				outstrm, mtu, frag,resp,op,UP;",
		"int				next_net, next_node;",
		"int				dest_net, dest_node,s_net,protocol;",
		"int				i,j,frag_accum, num_frags;",
		"int				frag_size, data_size, len,data_len;",
		"int				header_size, ttl;",
		"char			str0 [512], str1 [512];",
		"Packet			*pkptr, *ip_pkptr, *frag_ptr;",
		"Packet			*data_pkptr;",
		"",
		"int 			  term,join,grp_id,in_strm,join_pk;",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [2]' */
	tl_ptr [2] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [2], 
		"#include \"ip_frag_sup.h\"",
		"",
		"",
		"/* Macros Used to Represent Transitions. */",
		"#define QUEUE_EMPTY     	(op_q_empty ())",
		"#define SVC_COMPLETION  	((op_intrpt_type () == OPC_INTRPT_SELF) && (op_intrpt_code () == 0))",
		"#define ARRIVAL         	op_intrpt_type () == OPC_INTRPT_STRM",
		"#define MAC_UPD_OUTSTAT   0",
		"int   IGMP ; ",
		"int   QOSPF ; ",
		"int   UDP   ;  ",
		"int TCP ;",
		"int RSVP ;",
		"",
		"/* Default value for the time-to-live counter. */",
		"/* This value is assigned when a packet is received */",
		"/* which does not already have a ttl field. */",
		"#define IP_DEFAULT_TTL			32",
		"struct MC",
		"{  int interface[5];",
		"   int mtu[5];",
		"};",
		"typedef struct MC mc_id;",
		"",
		"int get_prio();",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [3]' */
	tl_ptr [3] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [3], 
		"int  get_prio(kpt)",
		"	Packet* kpt;",
		"{",
		"	int pro;",
		"	op_pk_nfd_get(kpt,\"prot_id\",&pro);",
		"	switch(pro) {",
		"	case 17: pro = 0;",
		"	     break;",
		"	case 8: pro = 0;",
		"	     break;",
		"	case 20: pro = 1;",
		"	     break;",
		"	case 9: pro = 1;",
		"	     break;",
		"	case 12: pro = 2;",
		"	     break;",
		"	default:  op_sim_end(\"Whaaaat pk is this?\",\"\",\"\",\"\");",
		"		}",
		"	return(pro);",
		"}",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [4]' */
	tl_ptr [4] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [4], 
		"op_prg_odb_print_major (\"State of Reassembly Table:\", OPC_NIL);",
		"ip_frag_sup_print (dgram_list_ptr);",
		"",
		VOSC_EOL);

	Ema_Model_Attr_Set (model_id,
		"state vars",           COMP_CONTENTS, tl_ptr [0],
		"temp vars",            COMP_CONTENTS, tl_ptr [1],
		"header block",         COMP_CONTENTS, tl_ptr [2],
		"function block",       COMP_CONTENTS, tl_ptr [3],
		"diag block",           COMP_CONTENTS, tl_ptr [4],
		EMAC_EOL);


	/* create model level attribute extensions */
	Ema_Model_Attr_Add (model_id, "service_rate", EMAC_DOUBLE, "pkts/sec", (double) 1);
	Ema_Model_Attr_Add (model_id, "net_num0", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num0", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num1", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num1", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num2", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num2", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num3", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num3", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num4", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num4", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "Indep_Rou", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "DEF_STRM", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Set (model_id,
		"service_rate",         COMP_PROMOTE, EMAC_DISABLED,
		"net_num0",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num0",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num1",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num1",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num2",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num2",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num3",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num3",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num4",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num4",            COMP_PROMOTE, EMAC_DISABLED,
		"Indep_Rou",            COMP_PROMOTE, EMAC_DISABLED,
		"DEF_STRM",             COMP_PROMOTE, EMAC_DISABLED,
		EMAC_EOL);



	/* assign attrs for object 'obj [0]' */
	/* create and init textlist 'tl_ptr [7]' */
	tl_ptr [7] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [7], 
		"IGMP = 9;",
		"UDP = 20;",
		"TCP = 12;",
		"RSVP = 8;",
		"QOSPF = 17;",
		"/* initially the server is idle */",
		"server_busy = 0;",
		"",
		"/* get queue module's own object id */",
		"own_id = op_id_self ();",
		"/* get assigned value of server processing rate */",
		"op_ima_obj_attr_get (own_id, \"service_rate\", &service_rate);",
		"op_ima_obj_attr_get (own_id, \"Indep_Rou\", &Indep_Rou);",
		"",
		"",
		"/* Obtain the assigned network and node numbers. */",
		"/* Note that this IP model supports multiple addresses */",
		"/* for gateways which may be members of several networks. */",
		"op_ima_obj_attr_get (own_id, \"net_num0\", &net_num0);",
		"op_ima_obj_attr_get (own_id, \"net_num1\", &net_num1);",
		"op_ima_obj_attr_get (own_id, \"net_num2\", &net_num2);",
		"op_ima_obj_attr_get (own_id, \"node_num0\", &node_num0);",
		"op_ima_obj_attr_get (own_id, \"node_num1\", &node_num1);",
		"op_ima_obj_attr_get (own_id, \"node_num2\", &node_num2);",
		"op_ima_obj_attr_get (own_id, \"net_num3\", &net_num3);",
		"op_ima_obj_attr_get (own_id, \"node_num3\", &node_num3);",
		"op_ima_obj_attr_get (own_id, \"net_num4\", &net_num4);",
		"op_ima_obj_attr_get (own_id, \"node_num4\", &node_num4);",
		"op_ima_obj_attr_get (own_id, \"DEF_STRM\", &def_str);",
		"",
		"",
		"/* Create a datagram list used to hold datagram fragments */",
		"/* Until complete datagrams can be reconstructed. */",
		"dgram_list_ptr = ip_frag_sup_setup ();",
		"",
		"",
		"/* Create an Ici for communicating destination addresses to arp. */",
		"arp_iciptr = op_ici_create (\"ip_arp_req\");",
		"",
		"for(i=0;i<100;++i)",
		"{",
		"  for(j=0;j<5;++j)",
		"    {  mc_table[i].interface[j]=-1;",
		"        mc_table[i].mtu[j] = 4096;",
		"    }",
		"} ",
		"if(!Indep_Rou)sub_netid=op_topo_parent(op_topo_parent(own_id));",
		"   else sub_netid=op_topo_parent(own_id);",
		"n_links = op_topo_assoc_count(sub_netid,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_LKSIMP);",
		"printf(\"N-links at %d = %d\\n\",net_num0,n_links);",
		"",
		"",
		"if(op_id_to_type(sub_netid) == OPC_OBJTYPE_SUBNET) gwy_type = 1;",
		"  else gwy_type = 0;",
		"",
		"/* for(i=0;, i< n_links ; ++i){",
		"    dup_lk_id = op_topo_assoc(sub_netid,OPC_TOPO_ASSOC_IN, OPC_OBJTYPE_LKDUP,i);",
		"    net_id = op_topo_assoc(dup_lk_id,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_SUBNET,0);",
		"		}*/",
		"/*printf(\"N_links for %d.%d = %d\\n\",net_num0, node_num0,n_links);*/",
		"",
		"for(i=0;i<400;++i) rte_tab[i] = def_str;",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [0], 
		"name",                 COMP_CONTENTS, "init",
		"enter execs",          COMP_CONTENTS, tl_ptr [7],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [1],
		"initial",              COMP_TOGGLE,   EMAC_ENABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [1]' */
	Ema_Object_Attr_Set (model_id, obj [1], 
		"x",                    COMP_CONTENTS, (double) 150,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [2]' */
	/* create and init textlist 'tl_ptr [9]' */
	tl_ptr [9] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [9], 
		"/* acquire the arriving packet */",
		"/* multiple arriving streams are supported. */",
		"in_strm = op_intrpt_strm();",
		"pkptr = op_pk_get (in_strm);",
		"",
		"/* If the received packet does not yet have a time-to-live */",
		"/* field assignment, place the default value in this field. */",
		"/* In this model, ttl is treated as a hop allowance decremented */",
		"/* by one prior to each transmission. If the decremented counter */",
		"/* reaches zero, the packet is not transmitted. */",
		"if (!op_pk_nfd_is_set (pkptr, \"ttl\"))",
		"	{",
		"	op_pk_nfd_set (pkptr, \"ttl\", IP_DEFAULT_TTL);",
		"	}",
		"op_pk_nfd_set(pkptr,\"strm\",in_strm);",
		"",
		"/* attempt to enqueue the packet at tail of subqueue 0 */",
		"if (op_subq_pk_insert (get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK)",
		"    {",
		"    /* the insertion failed (due to a full queue) */",
		"    /* deallocate the packet */",
		"    op_pk_destroy (pkptr);",
		"",
		"	/* set flag indicating insertion fail */",
		"	/* this flag is used to determine transition */",
		"	/* out of this state */",
		"    insert_ok = 0;",
		"    }",
		"else{",
		"	/* insertion was successful */",
		"    /*printf(\"Enqueuing the packet %d %d\\n\",net_num0,node_num0);*/",
		"    insert_ok = 1;",
		"    }",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [2], 
		"name",                 COMP_CONTENTS, "arrival",
		"enter execs",          COMP_CONTENTS, tl_ptr [9],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [3],
		EMAC_EOL);


	/* assign attrs for object 'obj [3]' */
	Ema_Object_Attr_Set (model_id, obj [3], 
		"x",                    COMP_CONTENTS, (double) 270,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [4]' */
	Ema_Object_Attr_Set (model_id, obj [4], 
		"name",                 COMP_CONTENTS, "idle",
		"position",             COMP_CONTENTS, obj [5],
		EMAC_EOL);


	/* assign attrs for object 'obj [5]' */
	Ema_Object_Attr_Set (model_id, obj [5], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 270,
		EMAC_EOL);


	/* assign attrs for object 'obj [6]' */
	/* create and init textlist 'tl_ptr [13]' */
	tl_ptr [13] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [13], 
		"/* determine the time required to complete */",
		"/* service of the packet */",
		"pk_svc_time = 1.0 / service_rate;",
		"",
		"/* schedule an interrupt for this process */",
		"/* at the time where service ends. */",
		"op_intrpt_schedule_self (op_sim_time () + pk_svc_time, 0);",
		"",
		"/* the server is now busy. */",
		"server_busy = 1;",
		"",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [6], 
		"name",                 COMP_CONTENTS, "svc_start",
		"enter execs",          COMP_CONTENTS, tl_ptr [13],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [7],
		EMAC_EOL);


	/* assign attrs for object 'obj [7]' */
	Ema_Object_Attr_Set (model_id, obj [7], 
		"x",                    COMP_CONTENTS, (double) 390,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [8]' */
	/* create and init textlist 'tl_ptr [15]' */
	tl_ptr [15] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [15], 
		"/* extract packet at head of queue */",
		"/* this is the packet just finishing service */",
		"for(i=0; i < 3; i++)",
		"{",
		"        if(op_subq_empty(i) == OPC_FALSE)",
		"        {",
		"	pkptr = op_subq_pk_remove (i, OPC_QPOS_HEAD);",
		"	break;",
		"	}",
		"}",
		"if(pkptr == OPC_NIL) op_sim_end(\"Can't get any packet from que????\",\"\",\"\",\"\");",
		"",
		"/* An IP packet has completed service */",
		"/* Obtain the destination network and node numbers. */",
		"op_pk_nfd_get (pkptr, \"dest_node\", &dest_node);",
		"op_pk_nfd_get (pkptr, \"dest_net\", &dest_net);",
		"op_pk_nfd_get(pkptr,\"src_net\",&s_net);",
		"op_pk_nfd_get(pkptr,\"prot_id\",&protocol);",
		"op_pk_nfd_get(pkptr,\"strm\",&in_strm);",
		"if(protocol == IGMP) rte_tab[s_net] = in_strm;",
		"UP = 0;",
		"if(dest_net == 500){   /*does this include data packets*/",
		"   UP = 1;",
		"  if(in_strm == 5 ) UP = 0; ",
		"		/*then it is a query going from this router or a response from this router*/",
		"   else",
		"    /*it's either a data from outside(2), or response to my query(3), or a query from another router(4)*/",
		"     if(protocol == UDP) UP = 0;",
		"                   }",
		"",
		"/* Determine the output stream on which to route it. */",
		" if(rte_tab[dest_net] == -1 && dest_net != 500 )",
		"	{",
		"  printf(\"Discarding b'cos no route\\n\");",
		"	/* If no route is provided, destroy the packet and issue a warning. */",
		"    printf(\"Destroying pk b'cos no route in svc_compl\\n\");",
		"    op_pk_destroy (pkptr);",
		"	}",
		"/* Otherwise, the packet can be routed or accepted. */",
		"else{",
		"	/* In the case of packets which have reached their destination, */",
		"	/* reassembly of ip fragments is performed at this point. */",
		"	if ((dest_net == net_num0 && dest_node == node_num0) ||",
		"		(dest_net == net_num1 && dest_node == node_num1) ||",
		"		(dest_net == net_num2 && dest_node == node_num2) ||",
		"		(dest_net == net_num3 && dest_node == node_num3) ||",
		"		(dest_net == net_num4 && dest_node == node_num4) || UP)",
		"		{",
		"		/* Call the fragment reassembly procedure to determine if */",
		"		/* a complete packet has arrived. Note that the packet */",
		"		/* will be destroyed in this procedure call unless it is */",
		"		/* itself the complete datagram (i.e., it isn't a fragment) */",
		"		if ((ip_pkptr = ip_frag_sup_insert (dgram_list_ptr, pkptr)) != OPC_NIL)",
		"			{",
		"			 if(protocol == IGMP)outstrm=5;",
		"			 if(protocol == 89)outstrm=6;         /*Lavu this's for u*/",
		"			 if(protocol == TCP) outstrm =7;",
		"			/* Forward the complete packet to the higher layer. */",
		"			op_pk_send (ip_pkptr, outstrm); ",
		"			}",
		"		}",
		"",
		"	/* For packets which have not reached their ultimate destination, */",
		"	/* They are forwarded to their next hop. */",
		"	else{   ",
		"		/* Decrement the packet's time-to-live field. If zero is reached, */",
		"		/* discard the packet rather than send it on. */",
		"		op_pk_nfd_get (pkptr, \"ttl\", &ttl);",
		"		ttl--;",
		"		if (ttl == 0)",
		"			{",
		"			/* due to an expired ttl. */",
		"			op_pk_destroy (pkptr);",
		"			}",
		"		else{",
		"			/* Assign the new decremented value of ttl. */",
		"   			op_pk_nfd_set (pkptr, \"ttl\", ttl);",
		"",
		"         if(dest_net != 500 )",
		"          {             outstrm = rte_tab[dest_net];",
		"			mtu = 4096;",
		"			/* Install an Ici indicating to the lower layer what the */",
		"			/* address of the next (intermediate) node is. */",
		"			op_ici_attr_set (arp_iciptr, \"next_node\", next_node);",
		"			op_ici_install (arp_iciptr);",
		"",
		"			/* Obtain the size in bytes of the fragment. */",
		"			frag_size = op_pk_total_size_get (pkptr) / 8;",
		"",
		"			/* Obtain the number of bytes of data carried in this fragment */",
		"			op_pk_nfd_get (pkptr, \"frag_len\", &data_size);",
		"",
		"			/* Also obtain the difference between the packet size */",
		"			/* and the length field: this is the size of the header. */",
		"			header_size = frag_size - data_size; ",
		"",
		"			/* If it is smaller than the maximum transfer unit, send it as is. */",
		"			if (frag_size <= mtu)",
		"				{",
		"				op_pk_send (pkptr, outstrm);",
		VOSC_EOL);

	Vos_Textlist_Append (tl_ptr [15], 
		"				}",
		"			else{			",
		"				/* Otherwise, break it into fragments */",
		"				/* Each fragment can contain up to (mtu - header_size) bytes of data */",
		"				num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);",
		"",
		"				/* In debug mode, indicate the fragmentation. */",
		"				if (op_prg_odb_ltrace_active (\"ip_frag\"))",
		"					{",
		"					sprintf (str0, \"Breaking datagram into (%d) fragments\", num_frags);",
		"					op_prg_odb_print_major (str0, OPC_NIL);",
		"					}",
		"",
		"				/* If the fragment is carrying the original datagram given to IP, */",
		"				/* extract it before copies are made. Only one fragment can carry */",
		"				/* the original packet for the reassembly model to work properly. */",
		"				if (op_pk_nfd_is_set (pkptr, \"ip_dgram\"))",
		"					op_pk_nfd_get (pkptr, \"ip_dgram\", &ip_pkptr);",
		"				else ip_pkptr = OPC_NIL;",
		"",
		"				/* If the packet is carrying any encapsulated data (normally this */",
		"				/* would happen only for a packet fragmented for the first time), */",
		"				/* extract this data packet so that it will not appear in each */",
		"				/* fragment generated by copying. */",
		"				if (op_pk_nfd_is_set (pkptr, \"data\"))",
		"					op_pk_nfd_get (pkptr, \"data\", &data_pkptr);",
		"				else data_pkptr = OPC_NIL;",
		"",
		"				/* Loop through and create the fragments . */",
		"				for (frag_accum = 0, i = 0; i < num_frags; i++)",
		"					{",
		"					/* Make a copy of the original packet. */",
		"					frag_ptr = op_pk_copy (pkptr);",
		"",
		"					/* Indicate that the copy is a fragment */",
		"					op_pk_nfd_set (frag_ptr, \"frag\", 1);",
		"",
		"					/* for all but the last fragment, the size is the mtu. */",
		"					/* and the encapsulated ip packet is not included. */",
		"					if (i < num_frags - 1)",
		"						{",
		"						op_pk_nfd_set (frag_ptr, \"frag_len\", mtu - header_size);",
		"						op_pk_total_size_set (frag_ptr, 8 * mtu);",
		"						frag_accum += (mtu - header_size);  ",
		"						}",
		"					else{",
		"						len = data_size - frag_accum;",
		"						op_pk_nfd_set (frag_ptr, \"frag_len\", len);",
		"						op_pk_total_size_set (frag_ptr,	8 * (header_size + len));",
		"",
		"						/* If the original packet was not a fragment, encapsulate it */",
		"						/* into the last fragment created here. */",
		"						op_pk_nfd_get (pkptr, \"frag\", &frag);",
		"						if (!frag)",
		"							{",
		"							/* If the packet contained encapsulated data (i.e., from the */",
		"							/* transport), that data will have been removed to avoid */",
		"							/* its duplication in the fragments. The data should now be */",
		"							/* reinserted into the original packet. */",
		"							if (data_pkptr != OPC_NIL)",
		"								op_pk_nfd_set (pkptr, \"data\", data_pkptr);",
		"",
		"							/* In either case the original packet is */",
		"							/* encapsulated in thhe fragment. */",
		"							op_pk_nfd_set (frag_ptr, \"ip_dgram\", pkptr);",
		"							}",
		"",
		"						/* Otherwise the packet can be discarded. */",
		"						else{",
		"							op_pk_destroy (pkptr);",
		"",
		"							/* Also, if the packet included the original datagram */",
		"							/* from which it was generated, transfer that datagram */",
		"							/* into the last fragment created here. */",
		"							/* Note that it is possible, in the case where a fragment */",
		"							/* is itself being fragmented, that none of the created */",
		"							/* fragments will contain the original datagram. */",
		"							if (ip_pkptr != OPC_NIL)",
		"								{",
		"								op_pk_nfd_set (frag_ptr, \"ip_dgram\", ip_pkptr);",
		"								}",
		"							}",
		"						}",
		"",
		"					/* Forward the datagram fragment. */",
		"					op_pk_send (frag_ptr, outstrm);",
		"					}	",
		"				}",
		"             }  /*mine for TCP packets*/",
		"else{",
		"if(gwy_type)",
		"{",
		"if(in_strm == 0 && protocol == UDP)op = 1;",
		"else op = 0;",
		"}",
		"else op = 1;",
		"",
		"if(dest_net == 500 )",
		"{  ip_pkptr = op_pk_copy(pkptr);   op_pk_destroy(pkptr);",
		"   while(op<n_links+1)",
		VOSC_EOL);

	Vos_Textlist_Append (tl_ptr [15], 
		"   { /*if(dest_node != 500){printf(\"link[%d] = %d\\n\",op,mc_table[dest_node].interface[op]);",
		"	getchar();}*/",
		"	if((mc_table[dest_node].interface[op] == 1 || dest_node == 500) && (op != in_strm) )",
		"	 {      mtu = 4096; ",
		"	/*	printf(\"Sending on link : %d at (%d.%d)\\n\",op,net_num0,node_num0);*/",
		"if( dest_node == 500) printf(\"Sending a query pk on %d from %d.%d IP\\n\",op,net_num0,node_num0);",
		"        	pkptr = op_pk_copy(ip_pkptr);",
		"       if(op == 0) /*means it's going to ethernet*/",
		"        {  next_node = 500+dest_node;",
		"           op_ici_attr_set(arp_iciptr,\"next_node\",next_node);",
		"           op_ici_install(arp_iciptr);",
		"        }",
		"      /*sending the pk*/",
		"			/* Obtain the size in bytes of the fragment. */",
		"			frag_size = op_pk_total_size_get (pkptr) / 8;",
		"			/* Obtain the number of bytes of data carried in this fragment */",
		"			op_pk_nfd_get (pkptr, \"frag_len\", &data_size);",
		"",
		"			/* Also obtain the difference between the packet size */",
		"			/* and the length field: this is the size of the header. */",
		"			header_size = frag_size - data_size; ",
		"",
		"			/* If it is smaller than the maximum transfer unit, send it as is. */",
		"			if (frag_size <= mtu)",
		"				{ /*printf(\"sending the pack from %d.%d to %d stream\\n\",net_num0,node_num0,op);    */",
		"				op_pk_send (pkptr, op);",
		"				}",
		"			else{			",
		"				/* Otherwise, break it into fragments */",
		"				/* Each fragment can contain up to (mtu - header_size) bytes of data */",
		"				num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);",
		"",
		"				/* In debug mode, indicate the fragmentation. */",
		"				if (op_prg_odb_ltrace_active (\"ip_frag\"))",
		"					{",
		"					sprintf (str0, \"Breaking datagram into (%d) fragments\", num_frags);",
		"					op_prg_odb_print_major (str0, OPC_NIL);",
		"					}",
		"",
		"				/* If the fragment is carrying the original datagram given to IP, */",
		"				/* extract it before copies are made. Only one fragment can carry */",
		"				/* the original packet for the reassembly model to work properly. */",
		"				if (op_pk_nfd_is_set (pkptr, \"ip_dgram\"))",
		"					op_pk_nfd_get (pkptr, \"ip_dgram\", &ip_pkptr);",
		"				else ip_pkptr = OPC_NIL;",
		"",
		"				/* If the packet is carrying any encapsulated data (normally this */",
		"				/* would happen only for a packet fragmented for the first time), */",
		"				/* extract this data packet so that it will not appear in each */",
		"				/* fragment generated by copying. */",
		"				if (op_pk_nfd_is_set (pkptr, \"data\"))",
		"					op_pk_nfd_get (pkptr, \"data\", &data_pkptr);",
		"				else data_pkptr = OPC_NIL;",
		"",
		"				/* Loop through and create the fragments . */",
		"				for (frag_accum = 0, i = 0; i < num_frags; i++)",
		"					{",
		"					/* Make a copy of the original packet. */",
		"					frag_ptr = op_pk_copy (pkptr);",
		"",
		"					/* Indicate that the copy is a fragment */",
		"					op_pk_nfd_set (frag_ptr, \"frag\", 1);",
		"",
		"					/* for all but the last fragment, the size is the mtu. */",
		"					/* and the encapsulated ip packet is not included. */",
		"					if (i < num_frags - 1)",
		"						{",
		"						op_pk_nfd_set (frag_ptr, \"frag_len\", mtu - header_size);",
		"						op_pk_total_size_set (frag_ptr, 8 * mtu);",
		"						frag_accum += (mtu - header_size);  ",
		"						}",
		"					else{",
		"						len = data_size - frag_accum;",
		"						op_pk_nfd_set (frag_ptr, \"frag_len\", len);",
		"						op_pk_total_size_set (frag_ptr,	8 * (header_size + len));",
		"						/* If the original packet was not a fragment, encapsulate it */",
		"						/* into the last fragment created here. */",
		"						op_pk_nfd_get (pkptr, \"frag\", &frag);",
		"						if (!frag)",
		"							{",
		"							/* If the packet contained encapsulated data (i.e., from the */",
		"							/* transport), that data will have been removed to avoid */",
		"							/* its duplication in the fragments. The data should now be */",
		"							/* reinserted into the original packet. */",
		"							if (data_pkptr != OPC_NIL)",
		"								op_pk_nfd_set (pkptr, \"data\", data_pkptr);",
		"",
		"							/* In either case the original packet is */",
		"							/* encapsulated in thhe fragment. */",
		"							op_pk_nfd_set (frag_ptr, \"ip_dgram\", pkptr);",
		"							}",
		"",
		"						/* Otherwise the packet can be discarded. */",
		"						else{",
		"							op_pk_destroy (pkptr);",
		"",
		"							/* Also, if the packet included the original datagram */",
		"							/* from which it was generated, transfer that datagram */",
		"							/* into the last fragment created here. */",
		"							/* Note that it is possible, in the case where a fragment */",
		VOSC_EOL);

	Vos_Textlist_Append (tl_ptr [15], 
		"							/* is itself being fragmented, that none of the created */",
		"							/* fragments will contain the original datagram. */",
		"							if (ip_pkptr != OPC_NIL)",
		"								{",
		"								op_pk_nfd_set (frag_ptr, \"ip_dgram\", ip_pkptr);",
		"								}",
		"							}",
		"						}",
		"",
		"					/* Forward the datagram fragment. */",
		"					op_pk_send (frag_ptr, op);",
		"					}	",
		"	 }",
		"    }",
		"    op++;",
		" }",
		" op_pk_destroy(ip_pkptr);",
		"}",
		"",
		"",
		"}",
		"			}",
		"		}",
		"	}",
		"",
		"/* The IP routing server becomes available again. */",
		"server_busy = 0;",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [16]' */
	tl_ptr [16] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [16], 
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [8], 
		"name",                 COMP_CONTENTS, "svc_compl",
		"enter execs",          COMP_CONTENTS, tl_ptr [15],
		"exit execs",           COMP_CONTENTS, tl_ptr [16],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [9],
		EMAC_EOL);


	/* assign attrs for object 'obj [9]' */
	Ema_Object_Attr_Set (model_id, obj [9], 
		"x",                    COMP_CONTENTS, (double) 510,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [10]' */
	Ema_Object_Attr_Set (model_id, obj [10], 
		"condition",            COMP_CONTENTS, "ARRIVAL",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [0],
		"drawing style",        COMP_TOGGLE,   EMAC_DISABLED,
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [11],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [12],
		"label pos",            COMP_CONTENTS, obj [13],
		EMAC_EOL);


	/* assign attrs for object 'obj [11]' */
	Ema_Object_Attr_Set (model_id, obj [11], 
		"x",                    COMP_CONTENTS, (double) 179,
		"y",                    COMP_CONTENTS, (double) 151,
		EMAC_EOL);


	/* assign attrs for object 'obj [12]' */
	Ema_Object_Attr_Set (model_id, obj [12], 
		"x",                    COMP_CONTENTS, (double) 240,
		"y",                    COMP_CONTENTS, (double) 151,
		EMAC_EOL);


	/* assign attrs for object 'obj [13]' */
	Ema_Object_Attr_Set (model_id, obj [13], 
		"x",                    COMP_CONTENTS, (double) 183,
		"y",                    COMP_CONTENTS, (double) 134,
		EMAC_EOL);


	/* assign attrs for object 'obj [14]' */
	Ema_Object_Attr_Set (model_id, obj [14], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [0],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [15],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [16],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [17],
		"path",                 COMP_ARRAY_CONTENTS (3), obj [18],
		"label pos",            COMP_CONTENTS, obj [19],
		EMAC_EOL);


	/* assign attrs for object 'obj [15]' */
	Ema_Object_Attr_Set (model_id, obj [15], 
		"x",                    COMP_CONTENTS, (double) 143,
		"y",                    COMP_CONTENTS, (double) 179,
		EMAC_EOL);


	/* assign attrs for object 'obj [16]' */
	Ema_Object_Attr_Set (model_id, obj [16], 
		"x",                    COMP_CONTENTS, (double) 166,
		"y",                    COMP_CONTENTS, (double) 264,
		EMAC_EOL);


	/* assign attrs for object 'obj [17]' */
	Ema_Object_Attr_Set (model_id, obj [17], 
		"x",                    COMP_CONTENTS, (double) 235,
		"y",                    COMP_CONTENTS, (double) 278,
		EMAC_EOL);


	/* assign attrs for object 'obj [18]' */
	Ema_Object_Attr_Set (model_id, obj [18], 
		"x",                    COMP_CONTENTS, (double) 301,
		"y",                    COMP_CONTENTS, (double) 278,
		EMAC_EOL);


	/* assign attrs for object 'obj [19]' */
	Ema_Object_Attr_Set (model_id, obj [19], 
		"x",                    COMP_CONTENTS, (double) 204,
		"y",                    COMP_CONTENTS, (double) 264,
		EMAC_EOL);


	/* assign attrs for object 'obj [20]' */
	Ema_Object_Attr_Set (model_id, obj [20], 
		"condition",            COMP_CONTENTS, "!server_busy && insert_ok",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [2],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [21],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [22],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [23],
		"label pos",            COMP_CONTENTS, obj [24],
		EMAC_EOL);


	/* assign attrs for object 'obj [21]' */
	Ema_Object_Attr_Set (model_id, obj [21], 
		"x",                    COMP_CONTENTS, (double) 291,
		"y",                    COMP_CONTENTS, (double) 129,
		EMAC_EOL);


	/* assign attrs for object 'obj [22]' */
	Ema_Object_Attr_Set (model_id, obj [22], 
		"x",                    COMP_CONTENTS, (double) 328,
		"y",                    COMP_CONTENTS, (double) 113,
		EMAC_EOL);


	/* assign attrs for object 'obj [23]' */
	Ema_Object_Attr_Set (model_id, obj [23], 
		"x",                    COMP_CONTENTS, (double) 370,
		"y",                    COMP_CONTENTS, (double) 127,
		EMAC_EOL);


	/* assign attrs for object 'obj [24]' */
	Ema_Object_Attr_Set (model_id, obj [24], 
		"x",                    COMP_CONTENTS, (double) 220,
		"y",                    COMP_CONTENTS, (double) 98,
		EMAC_EOL);


	/* assign attrs for object 'obj [25]' */
	Ema_Object_Attr_Set (model_id, obj [25], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [2],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [26],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [27],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [28],
		"label pos",            COMP_CONTENTS, obj [29],
		EMAC_EOL);


	/* assign attrs for object 'obj [26]' */
	Ema_Object_Attr_Set (model_id, obj [26], 
		"x",                    COMP_CONTENTS, (double) 266,
		"y",                    COMP_CONTENTS, (double) 179,
		EMAC_EOL);


	/* assign attrs for object 'obj [27]' */
	Ema_Object_Attr_Set (model_id, obj [27], 
		"x",                    COMP_CONTENTS, (double) 276,
		"y",                    COMP_CONTENTS, (double) 219,
		EMAC_EOL);


	/* assign attrs for object 'obj [28]' */
	Ema_Object_Attr_Set (model_id, obj [28], 
		"x",                    COMP_CONTENTS, (double) 309,
		"y",                    COMP_CONTENTS, (double) 248,
		EMAC_EOL);


	/* assign attrs for object 'obj [29]' */
	Ema_Object_Attr_Set (model_id, obj [29], 
		"x",                    COMP_CONTENTS, (double) 272,
		"y",                    COMP_CONTENTS, (double) 191,
		EMAC_EOL);


	/* assign attrs for object 'obj [30]' */
	Ema_Object_Attr_Set (model_id, obj [30], 
		"condition",            COMP_CONTENTS, "ARRIVAL",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [4],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [31],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [32],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [33],
		"label pos",            COMP_CONTENTS, obj [34],
		EMAC_EOL);


	/* assign attrs for object 'obj [31]' */
	Ema_Object_Attr_Set (model_id, obj [31], 
		"x",                    COMP_CONTENTS, (double) 300,
		"y",                    COMP_CONTENTS, (double) 267,
		EMAC_EOL);


	/* assign attrs for object 'obj [32]' */
	Ema_Object_Attr_Set (model_id, obj [32], 
		"x",                    COMP_CONTENTS, (double) 255,
		"y",                    COMP_CONTENTS, (double) 227,
		EMAC_EOL);


	/* assign attrs for object 'obj [33]' */
	Ema_Object_Attr_Set (model_id, obj [33], 
		"x",                    COMP_CONTENTS, (double) 256,
		"y",                    COMP_CONTENTS, (double) 176,
		EMAC_EOL);


	/* assign attrs for object 'obj [34]' */
	Ema_Object_Attr_Set (model_id, obj [34], 
		"x",                    COMP_CONTENTS, (double) 197,
		"y",                    COMP_CONTENTS, (double) 212,
		EMAC_EOL);


	/* assign attrs for object 'obj [35]' */
	Ema_Object_Attr_Set (model_id, obj [35], 
		"condition",            COMP_CONTENTS, "SVC_COMPLETION",
		"dest state",           COMP_CONTENTS, obj [8],
		"src state",            COMP_CONTENTS, obj [4],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [36],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [37],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [38],
		"label pos",            COMP_CONTENTS, obj [39],
		EMAC_EOL);


	/* assign attrs for object 'obj [36]' */
	Ema_Object_Attr_Set (model_id, obj [36], 
		"x",                    COMP_CONTENTS, (double) 356,
		"y",                    COMP_CONTENTS, (double) 284,
		EMAC_EOL);


	/* assign attrs for object 'obj [37]' */
	Ema_Object_Attr_Set (model_id, obj [37], 
		"x",                    COMP_CONTENTS, (double) 480,
		"y",                    COMP_CONTENTS, (double) 234,
		EMAC_EOL);


	/* assign attrs for object 'obj [38]' */
	Ema_Object_Attr_Set (model_id, obj [38], 
		"x",                    COMP_CONTENTS, (double) 519,
		"y",                    COMP_CONTENTS, (double) 178,
		EMAC_EOL);


	/* assign attrs for object 'obj [39]' */
	Ema_Object_Attr_Set (model_id, obj [39], 
		"x",                    COMP_CONTENTS, (double) 414,
		"y",                    COMP_CONTENTS, (double) 261,
		EMAC_EOL);


	/* assign attrs for object 'obj [40]' */
	Ema_Object_Attr_Set (model_id, obj [40], 
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [6],
		"drawing style",        COMP_TOGGLE,   EMAC_DISABLED,
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [41],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [42],
		"label pos",            COMP_CONTENTS, obj [43],
		EMAC_EOL);


	/* assign attrs for object 'obj [41]' */
	Ema_Object_Attr_Set (model_id, obj [41], 
		"x",                    COMP_CONTENTS, (double) 377,
		"y",                    COMP_CONTENTS, (double) 177,
		EMAC_EOL);


	/* assign attrs for object 'obj [42]' */
	Ema_Object_Attr_Set (model_id, obj [42], 
		"x",                    COMP_CONTENTS, (double) 335,
		"y",                    COMP_CONTENTS, (double) 240,
		EMAC_EOL);


	/* assign attrs for object 'obj [43]' */
	Ema_Object_Attr_Set (model_id, obj [43], 
		"x",                    COMP_CONTENTS, (double) 361,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [44]' */
	Ema_Object_Attr_Set (model_id, obj [44], 
		"condition",            COMP_CONTENTS, "!QUEUE_EMPTY",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [8],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [45],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [46],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [47],
		"label pos",            COMP_CONTENTS, obj [48],
		EMAC_EOL);


	/* assign attrs for object 'obj [45]' */
	Ema_Object_Attr_Set (model_id, obj [45], 
		"x",                    COMP_CONTENTS, (double) 489,
		"y",                    COMP_CONTENTS, (double) 127,
		EMAC_EOL);


	/* assign attrs for object 'obj [46]' */
	Ema_Object_Attr_Set (model_id, obj [46], 
		"x",                    COMP_CONTENTS, (double) 441,
		"y",                    COMP_CONTENTS, (double) 114,
		EMAC_EOL);


	/* assign attrs for object 'obj [47]' */
	Ema_Object_Attr_Set (model_id, obj [47], 
		"x",                    COMP_CONTENTS, (double) 405,
		"y",                    COMP_CONTENTS, (double) 124,
		EMAC_EOL);


	/* assign attrs for object 'obj [48]' */
	Ema_Object_Attr_Set (model_id, obj [48], 
		"x",                    COMP_CONTENTS, (double) 414,
		"y",                    COMP_CONTENTS, (double) 99,
		EMAC_EOL);


	/* assign attrs for object 'obj [49]' */
	Ema_Object_Attr_Set (model_id, obj [49], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [8],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [50],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [51],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [52],
		"label pos",            COMP_CONTENTS, obj [53],
		EMAC_EOL);


	/* assign attrs for object 'obj [50]' */
	Ema_Object_Attr_Set (model_id, obj [50], 
		"x",                    COMP_CONTENTS, (double) 486,
		"y",                    COMP_CONTENTS, (double) 169,
		EMAC_EOL);


	/* assign attrs for object 'obj [51]' */
	Ema_Object_Attr_Set (model_id, obj [51], 
		"x",                    COMP_CONTENTS, (double) 453,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [52]' */
	Ema_Object_Attr_Set (model_id, obj [52], 
		"x",                    COMP_CONTENTS, (double) 355,
		"y",                    COMP_CONTENTS, (double) 253,
		EMAC_EOL);


	/* assign attrs for object 'obj [53]' */
	Ema_Object_Attr_Set (model_id, obj [53], 
		"x",                    COMP_CONTENTS, (double) 398,
		"y",                    COMP_CONTENTS, (double) 202,
		EMAC_EOL);








	/* write the model to application-readable form */
	Ema_Model_Write (model_id, "ip_gwy");

	}

